function [] = print_route(w12, b2, w23, b3, HiddenFunc, OutFunc)
% PRINT_ROUTE : Search a route by using the Q table. 
%           Then, display the route.
%
% Syntax : PRINT_ROUTE(Q_table);
%
% Input  : Q_table (Requred) : N x 4 (The number of states x The number of actions)
%
% Output : 
% 
% See also TABLE, DISP, PRINT_QTABLE.

    maze_i = 3;
    maze_j = 3;
    
    disp('oH Route:');
    s = 1;                  % Initial State : S1

    for i=1:9             % Maximum length of the route : 9
        st = zeros(maze_i*maze_j, 1);
        st(s) = 1;
        
        % Input (State Number)
        X = st;
        
        z2 = w12.' * X + b2;                % Bw̏dݕtaz2
        if(HiddenFunc == "sigmoid")
            a2 = 1./(1+exp(-z2));               % Bw̏oa2i֐FVOCh֐j
        end
        
        z3 = w23.' * a2 + b3;               % o͑w̏dݕtaz3
        if(OutFunc == 'Linear')
            a3 = z3;    
        end
        
        Qt = a3;
        max_value = max(Qt);
        for j = 1 : 4
            if max_value == Qt(j)
                I = j ;     % sCDecide the action in state t.
            end
        end
        
        if s == 9          % S9S[DS[ɓƃS[ƕ\
            fprintf('(S%d) Goal!\n', s);
            break
        end

        fprintf('(S%d,%d)', s, I);        % ̏ԁioHj\. Display the state t.

        % H̎̕ǂɂԂ[̏ԁiʒujǂȉ̂悤Ȏ
        % pāC[łȂꍇɎ̏ԁiʒu)Ɉړ悤ɏĂD
        % ̕ǂɂԂ悤ł Error \D
        %
        % rem(s,5) == 0     (A1CE[ s3, s6, s9)
        % s <= 5            (A2C[ s1 - s3)
        % rem(s,5) == 1     (A3C[ s1, s4, s7)
        % s  >= 21          (A4C[ s7 - s9)
        %
        if I == 1                   % If the action of the agent on the state,  
            if rem(s,3) ~= 0        % (that is not the far right) is one (right),
                s = s+1;            % the agent moves to next state (state s+1).
            else
                disp('Error');
                break
            end
        elseif I == 2               % Action : 2 (up), state is not at the top
            if s > 3
                s = s-3;            % the agent moves to the next state (s-3: 3x3)
            else
                disp('Error');
                break
            end
        elseif I == 3               % Action : 3 (left), state is not on the left side
            if rem(s,3) ~= 1
                s = s-1;            % the agent moves to the next state (s-3: 3x3)
            else
                disp('Error');
                break
            end
        elseif I == 4               % Action : 4 (down), state is not at the bottom
            if s < 7
                s = s+3;            % the agent moves to the next state (s+3: 3x3)
            else
                disp('Error');
                break
            end
        end
    end
    
    if i == 25                      % Maximum length of the route : 25
        disp('Error');              % Œ[głS[ɂǂ蒅ȂꍇCError
    end
    disp(' ');disp(' ');
end